/* ******************************************************************************

	FILE:			SSTexture.h
	AUTHOR:			Jean-Sebastien Perrier

	DESCRIPTION:	OpenGL wrapper for texture management.

****************************************************************************** */

#ifdef _MSC_VER
	#pragma once
#endif
#ifndef SSTEXTURE_H
#define SSTEXTURE_H

// Includes ****************************************************************** //

// Defines ******************************************************************* //

// Forward definitions ******************************************************* //

// Types ********************************************************************* //

class SSTexture
{
private:
	char m_szFilename[128];
	bool m_bLoaded;
	bool m_bMipmap;
	unsigned int m_unTextureID;		// OpenGL's texture ID.

private:
	bool LoadImage();
	static SSTexture *s_pLastApplied;

public:

	SSTexture(const char *filename, bool a_bMipmap = true);
	virtual ~SSTexture();

	void Apply();
};

// Consts ******************************************************************** //

// Globals ******************************************************************* //

// Function Prototypes ******************************************************* //

// Inline Functions ********************************************************** //

#endif // SSTEXTURE_H
